## org.eclipse.ocl.parser.backtracking
Class OCLBacktrackingParser

    java.lang.Object
      lpg.lpgjavaruntime.PrsStream
          org.eclipse.ocl.lpg.AbstractParser
              org.eclipse.ocl.parser.AbstractOCLParser
                  org.eclipse.ocl.parser.backtracking.OCLBacktrackingParser

All Implemented Interfaces:
  lpg.lpgjavaruntime.ParseErrorCodes, lpg.lpgjavaruntime.RuleAction, lpg.lpgjavaruntime.TokenStream

    public class OCLBacktrackingParser

extends AbstractOCLParser
implements lpg.lpgjavaruntime.RuleAction

The backtracking variant of the OCL parser.

Since:
  1.3

Field Summary
`protected static lpg.lpgjavaruntime.ParseTable` `prs`

Fields inherited from interface lpg.lpgjavaruntime.ParseErrorCodes
`BEFORE_CODE, DELETION_CODE, EOF_CODE, ERROR_CODE, errorMsgText, INSERTION_CODE, INVALID_CODE, INVALID_TOKEN_CODE, LEX_ERROR_CODE, MERGE_CODE, MISPLACED_CODE, SCOPE_CODE, SECONDARY_CODE, SUBSTITUTION_CODE`

Constructor Summary
`OCLBacktrackingParser(OCLBacktrackingLexer lexer)`

Method Summary
`int` `getEOFTokenKind()`
`OCLBacktrackingLexer` `getLexer()`
`Environment<?,?,?,?,?,?,?,?,?,?,?,?>` `getOCLEnvironment()`
`String` `getTokenKindName(int kind)`
`String[]` `orderedTerminalSymbols()`
`CSTNode` `parseTokensToCST(lpg.lpgjavaruntime.Monitor monitor, int error_repair_count)`
`void` `ruleAction(int ruleNumber)`
`protected void` `setOffsets(CSTNode cstNode)` Initializes a concrete-syntax node's start and end offsets from the current token in the parser stream.

Methods inherited from class org.eclipse.ocl.parser.AbstractOCLParser

`createBooleanLiteralExpCS, createClassifierContextDeclCS, createClassifierContextDeclCS, createCollectionLiteralExpCS, createCollectionLiteralPartCS, createCollectionRangeCS, createCollectionTypeCS, createDefCS, createDefCS, createDefExpressionCS, createDerValueCS, createEnumLiteralExpCS, createEnumLiteralExpCS, createFeatureCallExpCS, createIfExpCS, createInitValueCS, createIntegerLiteralExpCS, createInvalidLiteralExpCS, createInvCS, createInvCS, createIsMarkedPreCS, createIterateExpCS, createIteratorExpCS, createLetExpCS, createMessageExpCS, createNullLiteralExpCS, createOCLDocumentCS, createOCLMessageArgCS, createOperationCallExpCS, createOperationCallExpCS, createOperationCallExpCS, createOperationCallExpCS, createOperationContextDeclCS, createOperationCS, createOperationCS, createPackageDeclarationCS, createPathNameCS, createPathNameCS, createPrePostOrBodyDeclCS, createPrimitiveTypeCS, createPropertyContextCS, createRangeStart, createRealLiteralExpCS, createSimpleNameCS, createStateExpCS, createStringLiteralExpCS, createTupleLiteralExpCS, createTupleTypeCS, createUnlimitedNaturalLiteralExpCS, createVariableCS, createVariableExpCS, extendPathNameCS, isAtPre, isNonStdSQSupported, unescape`

Methods inherited from class org.eclipse.ocl.lpg.AbstractParser
`computeInputString, getDefaultRepairCount, getEnvironment, getErrorTokenAtCharacter, getErrorTokens, getTokenIndexAtCharacter, makeErrorToken, parseTokensToCST, reportError, reportErrorTokenMessage, resetLexStream, setDefaultRepairCount, setLexStream, setOffsets, setOffsets, setOffsets, setOffsets, setOffsets, setOffsets, unquote`

Methods inherited from class lpg.lpgjavaruntime.PrsStream

`addAdjunct, addToken, afterEol, badToken, dumpToken, dumpTokens, getAdjuncts, getColumn, getColumnOfTokenAt, getEndColumn, getEndColumnOfTokenAt, getEndLine, getEndLineNumberOfTokenAt, getEndOffset, getFileName, getFirstErrorToken, getFirstRealToken, getFollowingAdjuncts, getInputChars, getIToken, getKind, getLastErrorToken, getLastRealToken, getLexStream, getLine, getLineNumberOfTokenAt, getName, getNext, getPrecedingAdjuncts, getPrevious, getSize, getStartOffset, getStreamIndex, getStreamLength, getToken, getToken, getTokenAt, getTokenAtCharacter, getTokenLength, getTokens, getTokenText, makeAdjunct, makeToken, mapKind, peek, remapTerminalSymbols, reportError, reportError, reportError, reset, reset, resetTokenStream, setSize, setStreamIndex, setStreamLength, setStreamLength`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### prs

    protected static lpg.lpgjavaruntime.ParseTable prs

Constructor Detail

### OCLBacktrackingParser

    public OCLBacktrackingParser(OCLBacktrackingLexer lexer)

Method Detail

### getEOFTokenKind

    public int getEOFTokenKind()

### getOCLEnvironment

    public Environment<?,?,?,?,?,?,?,?,?,?,?,?> getOCLEnvironment()

### getLexer

    public OCLBacktrackingLexer getLexer()

  Overrides:
    `getLexer` in class `AbstractParser`

### getTokenKindName

    public String getTokenKindName(int kind)

### orderedTerminalSymbols

    public String[] orderedTerminalSymbols()

  Overrides:
    `orderedTerminalSymbols` in class `lpg.lpgjavaruntime.PrsStream`

### parseTokensToCST

    public CSTNode parseTokensToCST(lpg.lpgjavaruntime.Monitor monitor,
                                    int error_repair_count)

  Specified by:
    `parseTokensToCST` in class `AbstractParser`

### setOffsets

    protected void setOffsets(CSTNode cstNode)

  Initializes a concrete-syntax node's start and end offsets from the current token in the parser stream.

  Parameters:
    `cstNode` - a concrete-syntax node
  Since:
    1.2

### ruleAction

    public void ruleAction(int ruleNumber)

  Specified by:
    `ruleAction` in interface `lpg.lpgjavaruntime.RuleAction`

Copyright 2002, 2007 IBM Corporation and others. All Rights Reserved.